require 'sketchup.rb'

module FHGelsenkirchen
  class BatchExporter
    def initialize
      @files = Hash.new()
      @filepath = ""

      JF::RubyToolbar::openConsole
      getDirectory()
    end

    def getDirectory()
      width = 400
      height = 200
      dlg = UI::WebDialog.new("CityGML Batch Exporter", true, "CityGML Batch Exporter", width, height, 0, 0, true)
      dlg.max_width = width
      dlg.min_width = width
      dlg.max_height = height
      dlg.min_height = height
      dlg.set_html(filePathhtml())

      dlg.add_action_callback("FilePath") {|dialog, params|
        @filepath = params
        dlg.close()
        export()
      }

      dlg.show()
    end

    def export()
      begin
        if(findDirectories(@filepath))
          CityGMLExport.new(true,@files)
        else
          puts "Directorie not found!"
        end
      rescue => e
        puts e
        puts e.backtrace
      end
    end

    def findDirectories(path)
      begin
        Dir.chdir(path)
        fileList = Dir["*.skp"]
        fileList.each do |file|
          xmlname = path + "\\" + file.chomp(File.extname(file)) + ".xml"
          @files[path + "\\" + file] = xmlname
        end
        subdir_list=Dir["*"].reject{|o| not File.directory?(o)}
        subdir_list.each do |subdir|
          findDirectories(path + "\\" + subdir)
        end
      rescue => e
        return false
      end
      return true
    end

    def filePathhtml()
      html = '
       <html>
       <head>

       </head>
       <body>
       <script type="text/javascript">
        function transmit()
        {
          window.location = "skp:FilePath@" + document.getElementById("path").value;
        }
       </script>
       Directory:&nbsp<input id="path" name="path" type="text" size="50" maxlength="100" value=""><br />
       <input type="button" name="ok_button" value="Ok" onclick="transmit()">
       </body>
       </html>
      '
      return html
    end
  end
end