require 'sketchup'
module FHGelsenkirchen
  #Dialog, der beim Importieren angezeigt wird
  class GMLOptionsDialog
    #Gibt das HTML als String zurück
    #Parameter 1: bool, ob Lod 1 beim Parsen gefunden wurde
    #Parameter 2: bool, ob Lod 2 beim Parsen gefunden wurde
    #Parameter 3: bool, ob Lod 3 beim Parsen gefunden wurde
    #Parameter 4: bool, ob Lod 3 beim Parsen gefunden wurde
    #Parameter 5: Name der Datei, wird als Layer vorgeschlagen
    def self.createDialog(lod1, lod2, lod3, lod4, gmlname)
      html = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
      "http://www.w3.org/TR/html4/strict.dtd">
      <html>
      <script>
      function setlayername(i)
      {
        layername = document.getElementById("layername").value = "' + gmlname + '-Lod"+ i + "-Layer";
      }
      function move_to_center() {
         window.location = "skp:move@" + screen.width + "," + screen.height + ":" + document.body.offsetWidth + "," + document.body.offsetHeight;
      }
      function ground()
      {
        layername = document.getElementById("layername");
        if(document.getElementById("boden").checked)
        {
          layername.disabled = true;
          document.getElementById("layername").value = "Boden";
        }
        else
          layername.disabled = false;
      }

      function layercheck()
      {
        layer = document.getElementById("layer");
        layername = document.getElementById("layername");
        if(layer.checked)
          layername.disabled = false;
        else
          layername.disabled = true;

      }

      function exit()
      {
        window.location = \'skp:exit\';
      }

      function Choosen ()
      {
        if(document.getElementById("layer").checked)
          name = document.getElementById("layername").value;
        else
          name = "";
        lods = document.getElementsByName("LOD");
        lod = -1;
        for( var i=0; i<lods.length; i++)
        {
          if(lods[i].checked)
          {
            lod = ++i;
            break;
          }
        }
        coords = document.getElementsByName("Coords");
        coord = -1;
        for( var i=0; i<coords.length; i++)
        {
          if(coords[i].checked)
          {
            coord = ++i;
            break;
          }
        }
        material = 1;
        faktor = parseFloat(document.getElementById("faktor").value);
        if(isNaN(faktor))
        {
          alert("Kein gültiger Einheiten Umrechnungsfaktor");
          return;
        }
        if(lod != -1 && material != -1)
        {
          window.location = \'skp:choosen@\' + lod + ";" + material + ";" + document.getElementById("layer").checked + ";" + name + ";" + faktor + ";" + coord;
          return;
        }
        alert("Keine Auswahl getroffen");

      }

      </script>
      <head>
      <title></title>
      </head>
      <body onLoad="move_to_center()">
      <form action="test.html">

    <!-- <p>Modelltyp<br/>
    &nbsp;<input id= "boden" type="radio" name="boden" checked >Stadtmodell</br>
    &nbsp;<input id= "boden" type="radio" name="boden" >Bodenmodell
    </p> -->
    <p>
      LOD choice:</br>'
      maxlod = 1 if(lod1)
      maxlod = 2 if(lod2)
      maxlod = 3 if(lod3)
      maxlod = 4 if(lod4)
      if(lod1)
        if(1 == maxlod)
          html += '&nbsp;<input type="radio" name="LOD" value="1" checked onclick="setlayername(1)">LOD1<br/>'
        else
          html += '&nbsp;<input type="radio" name="LOD" value="1" onclick="setlayername(1)">LOD1<br/>'
        end
      else
        html += '&nbsp;<input type="radio" name="LOD" value="1" disabled><font color="#A9A9A9">LOD1</font><br/>'
      end

      if(lod2)
        if(2 == maxlod)
          html += '&nbsp;<input type="radio" name="LOD" value="2" checked onclick="setlayername(2)">LOD2<br/>'
        else
          html += '&nbsp;<input type="radio" name="LOD" value="2" onclick="setlayername(2)">LOD2<br/>'
        end
      else
        html += '&nbsp;<input type="radio" name="LOD" value="2" disabled><font color="#A9A9A9">LOD2</font><br/>'
      end

      if(lod3)
        if(3 == maxlod)
          html += '&nbsp;<input type="radio" name="LOD" value="3" checked onclick="setlayername(3)">LOD3<br/>'
        else
          html += '&nbsp;<input type="radio" name="LOD" value="3" onclick="setlayername(3)">LOD3<br/>'
        end
      else
        html += '&nbsp;<input type="radio" name="LOD" value="3"disabled><font color="#A9A9A9">LOD3</font><br/>'
      end

      if(lod4)
        if(4 == maxlod)
          html += '&nbsp;<input type="radio" name="LOD" value="4" checked onclick="setlayername(4)">LOD4<br/>'
        else
          html += '&nbsp;<input type="radio" name="LOD" value="4" onclick="setlayername(4)">LOD4<br/>'
        end

      else
        html += '&nbsp;<input type="radio" name="LOD" value="4" disabled><font color="#A9A9A9">LOD4</font><br/>'
      end
      html += '
      <p>
      Coordinates:<br/>
&nbsp;<input type="radio" name="Coords" value="1" checked >Easting, Northing<br/>
&nbsp;<input type="radio" name="Coords" value="2">Northing, Easting<br/>
    </p>
    <p>
      <input id= "layer" type="checkbox" name="layer" onclick="layercheck()" checked>Assign model to a new layer </br>
    &nbsp;&nbsp;&nbsp;<input id= "layername" name="layername" type="text" size="30" maxlength="30" value="' + gmlname + '-Lod' +maxlod.to_s() +  '"><br>
    </p>
  <input id="faktor" name="faktor" type="hidden" size="30" maxlength="30" value="1">

  <p><input type="button" name="SetLOD" value="Abort" onclick="exit()">&nbsp;&nbsp;&nbsp;<input type="button" name="SetLOD" value="Start import" onclick="Choosen()"></p>
      </form>
      </body>
      </html>'
      return html
    end
  end
end