require 'CityGML/Objects/CityModel'
require 'CityGML/Handler/CityObjectMemberHandler'
require 'CityGML/Handler/SimpleGMLHandler'
require 'CityGML/Handler/CityModelHandler'
require 'libxml'
require 'xml'

module FHGelsenkirchen
  #GML Parser
  class GMLParserException < Exception
    public 
    def initialize(message=nil)
      if(message==nil)
        super()
      else
        super(message)
      end
    end
  end

  class GMLStatistics
    attr_accessor :TopLevelElements
    attr_accessor :XMLElements
    attr_accessor :XMLFileSize
    attr_accessor :Warnings
    
    def initialize
      # @Warnings = Hash.new()
      @XMLElements = 0
    end
  end

  #Klasse um CityGML Modelle zu lesen
  class GMLParser
    
    attr_reader :Model #Das Object welches der GML Datei entspricht
    class SaxGMLHandler
      include XML::SaxParser::Callbacks
      @curHandler #zeigt immer auf den aktuellen Handler, dient zur Typabfrage
      #@@DebugXMLLine
      @bSaveOtherTags
   
      def initialize(model, bSaveOtherTags, sXmlFile)
        @testhash = Hash.new()
        @p = 0
        @testi = 1
        @parser = XML::SaxParser.file(sXmlFile)
        @parser.callbacks= self
        @bSaveOtherTags = bSaveOtherTags
        @Model = model
        SimpleGMLHandler.setModel(model)  # ToDo Implementieren
        @CityObjectHandler = CityModelHandler.new(bSaveOtherTags) #ToDo Implementieren
        @curHandler = @CityObjectHandler
        @@GMLStatistics = GMLStatistics.new()
        @curHandler.resetHandler(@curHandler, @Model)
      end

      def on_start_element_ns(name, attributes, prefix, uri, namespaces)
        
        #if(name == "Building")
        #  puts @testi
        #   begin
        #     if(@testhash.fetch(attributes["id"].to_s))
        #       UI.messagebox "Doppelte ID: " + attributes["id"].to_s, MB_OK
        #     end
        #    rescue => e
        #        puts e
        #       @testhash[attributes["id"].to_s] = true
        #    end
        #     @flag = true if(attributes["id"].to_s == "DENW013D00002457f")
        #     UI.messagebox "Building auf " + attributes["id"].to_s, MB_OK if @flag
        #   end
        # @testi += 1
        @@GMLStatistics.XMLElements += 1
        @curHandler = @curHandler.on_start_element_ns(name, attributes, prefix, uri, namespaces)
      end

      def on_end_element_ns(name, prefix, uri)
        #if(name == "Building")
        # UI.messagebox "Building zu", MB_OK
        #end
        b = @curHandler.on_end_element_ns(name, prefix, uri)
        #puts b
        if(b)
          @curHandler = @curHandler.ParentHandler
        end
      end
    
      def on_characters(chars)
        # if(chars.length > 0)
        #  UI.messagebox chars, MB_OK
        #end
        #puts chars
        @curHandler.on_characters(chars)
      end


      def parse()
        @parser.parse()
      end
    end

    @XMLReader
    @XMLStream
    @ParserHandler

    def initialize()
      @@bParsing = false
    end

    def parse(sXmlFile, bSaveOtherTags)
      puts "#{File.basename(sXmlFile)} is parsed..."
      puts "Please wait a moment"
      if (@@bParsing)
        raise Exception,"Keine paralleles Parsen möglich"
      end
      @@bParsing = true
      @@GMLStatistics = GMLStatistics.new()
      @Model = CityModel.new(nil, "CityModel", nil, bSaveOtherTags)
      #doc = XML::Document.file(sXmlFile)
      @ParserHandler = SaxGMLHandler.new(@Model, bSaveOtherTags, sXmlFile)
      @ParserHandler.parse()
      #rawxml = File.new(sXmlFile).read()
      #parser = REXML::Parsers::SAX2Parser.new(rawxml)
      #parser.listen(@ParserHandler)
      #parser.parse()
      puts "Parsing completed."
      return @Model
    end
  end
end
