require 'CityGML/Handler/SimpleGMLHandler'

module FHGelsenkirchen
  class BoundedByHandler < SimpleGMLHandler
    def BoundedBy()
      return @curObject
    end

    def initialize(bSaveOtherTags)
      super(bSaveOtherTags)
      @LodXHandler = LodXHandler.new(bSaveOtherTags)
    end

    def on_start_element_ns(name, attributes, prefix, uri, namespaces)
      f = 0
      qname = FHGelsenkirchen::createQname(prefix, name)
      case(name)
      when "RoofSurface"
        @curObject.surfaceTyp = "RoofSurface"
        #@curObject.surfaceAttributes = SimpleGMLHandler::saveAttributes(attributes)
        @curObject.surfaceAttributes = attributes["id"] if(attributes["id"] != nil)
      when "WallSurface"
        @curObject.surfaceTyp = "WallSurface"
        #@curObject.surfaceAttributes = SimpleGMLHandler::saveAttributes(attributes)
        @curObject.surfaceAttributes = attributes["id"] if(attributes["id"] != nil)
      when "GroundSurface"
        @curObject.surfaceTyp = "GroundSurface"
        #@curObject.surfaceAttributes = SimpleGMLHandler::saveAttributes(attributes)
        @curObject.surfaceAttributes = attributes["id"] if(attributes["id"] != nil)
      when "lod1Solid" then f = 1
      when "lod1MultiSurface" then f = 1
      when "lod2Solid" then f = 1
      when "lod2MultiSurface" then f = 1
      when "lod3Solid" then f = 1
      when "lod3MultiSurface" then f = 1
      when "lod4Solid" then f = 1
      when "lod4MultiSurface" then f = 1
      when "lod1Geometry" then f = 1
      when "lod2Geometry" then f = 1
      when "lod3Geometry" then f = 1
      when "lod4Geometry" then f = 1
      end
      if(f == 1)
        #Eventuelle PreObjects speichern
        if (@curObject.PreObjects == nil || @curObject.PreObjects.empty? )
          SaveCurrentPreObjects()
        end
        #neues Objekt anlegen
        curLOD = (name.delete("lod").to_i) -1  #gespeichert werden direkt ArrayIndices
        @@Model.LOD[curLOD] = true #Speicher welche LODs vorkommen
        newLodXObject = LodXObject.new(@curObject,qname, attributes, @bSaveOtherTags)
        @curObject.ObjectLOD = curLOD
        @curObject.LodXObject = newLodXObject
        #Handler reset
        @LodXHandler.resetHandler(self, newLodXObject)
        return @LodXHandler
      end
      return super(name, attributes, prefix, uri, namespaces)
    end
  end
end
