require 'CityGML/Handler/SimpleGMLHandler'
require 'CityGML/Handler/AppearanceMemberHandler'
require 'CityGML/Objects/AppearanceMember'
require 'CityGML/Objects/CityModel'
module FHGelsenkirchen
  class CityModelHandler < SimpleGMLHandler

    def initialize( bSaveOtherTags)
      super(bSaveOtherTags)
      @AppearanceMemberHandler = AppearanceMemberHandler.new(bSaveOtherTags)
      @CharBuffer = ""
      @CityObjectMemberHandler = CityObjectMemberHandler.new(bSaveOtherTags)
      @bParsingDescription = false
      @bParsingName = false
      @CityObjectMemberHandler.resetHandler(self, @CityObjectMemberHandler.curObject)
      @curObject = @@Model

    end

    def on_start_element_ns(name, attributes, prefix, uri, namespaces)
      #GMLParser.GMLStatistics.TopLevelElements += 1
      qname = FHGelsenkirchen::createQname(prefix, name)
      case (name)
      when "CityModel":
          namespaces.each_pair{|key, value|
          if(key == "xmlns")
            @curObject.Namespaces << "xmlns=\"#{value}\""
          else
            @curObject.Namespaces << "xmlns:#{key}=\"#{value}\""
          end
        }
        return self
      when "name":
          @bParsingName = true
        super(name, attributes, prefix, uri, namespaces)
        return self
      when "description"
        @bParsingDescription = true
        super(name, attributes, prefix, uri, namespaces)
        return self
      when "cityObjectMember":
          #cityObjectMember ist abstrakt, nicht weiter zu tun außer weiterreichen
        SaveCurrentPreObjects()
        return @CityObjectMemberHandler;
      when "appearanceMember":
          @@Model.AppearanceMember << AppearanceMember.new(@@Model, qname, attributes, @bSaveOtherTags)
        @AppearanceMemberHandler.resetHandler(self, @@Model.AppearanceMember[-1], false);
        return @AppearanceMemberHandler;
      else
        return super(name, attributes, prefix, uri, namespaces)
        #return self
      end
    end

    def on_end_element_ns(name, prefix, uri)
      case(name)
      when "name":
          @bParsingName = false
        @curObject.Name = @CharBuffer
        @CharBuffer = ""
      when "description"
        @bParsingDescription = false
        @curObject.Description = @CharBuffer
        @CharBuffer = ""
      end
      super(name, prefix, uri)
    end

    def on_characters(chars)
      if(@bParsingDescription or @bParsingName)
        @CharBuffer << chars
      end
      super(chars)
    end

  end
end