require 'CityGML/Handler/SimpleGMLHandler'

module FHGelsenkirchen
  class CityObjectGroupHandler < SimpleGMLHandler
    attr_accessor :CityObjectGroup

    def initialize(bSaveOtherTags)
      super(bSaveOtherTags)

      @Generic3DObjectHandler = Generic3DObjectHandler.new(bSaveOtherTags)
      @curGroupMember = AbstractGMLDummy.new(@@Model, "CityObjectGroup", nil, bSaveOtherTags)
      @bIgnoring = false
      @IgnoredQName = ""
      @bSeenGroupMember = false
    end

    def resetHandler(newParent, newObject)
      @bSeenGroupMember = false
      @bIgnoring = false
      @IgnoredQName = ""
      @curGroupMember = nil
      super(newParent, newObject)
    end

    def on_start_element_ns(name, attributes, prefix, uri, namespaces)
      qname = FHGelsenkirchen::createQname(prefix, name)
      if (name == "groupMember")  #umschließt die eigentlichen Member
        @bSeenGroupMember = true
        #Eventuelle PreObjects speichern
        if (@curObject.PreObjects == nil || @curObject.PreObjects.empty?)
          SaveCurrentPreObjects()
        end
        #neues Objekt anlegen
        newGroupMember = GroupMember.new(@curObject, qname, attributes, @bSaveOtherTags)
        #newGroupMember.DebugLine = GMLParser.SaxGMLHandler.DebugXMLLine
        @curGroupMember = newGroupMember
        @curObject.GroupMember << newGroupMember
        return self
      elsif(@Generic3DObjectHandler.Implemented3DObjects.include?(name))   #handelt es sich um ein Generic3DObject?
        #neues Objekt anlegen
        newGeneric3DObject = Generic3DObject.new(@curObject, qname, attributes, @bSaveOtherTags)
        #newGeneric3DObject.DebugLine = GMLParser.SaxGMLHandler.DebugXMLLine
        @curGroupMember.GMLObject = newGeneric3DObject
        #Handler reset
        @Generic3DObjectHandler.resetHandler(self, newGeneric3DObject)
        return @Generic3DObjectHandler
      elsif (@bSeenGroupMember)   #sonst ist dieses Element noch nicht implementiert -> Warnung generieren
        if (!@bIgnoring)
          puts "Warning: groupMember \"#{qname}\" was ignored";
          # if (!GMLParser.GMLStatistics.Warnings.ContainsKey(warning))
          #   GMLParser.GMLStatistics.Warnings.Add(warning, 1)
          # else
          #   GMLParser.GMLStatistics.Warnings[warning] += 1
          # end
          @IgnoredQName = qname
        end
        m_bIgnoring = true
        return self
      else
        return super(name, attributes, prefix, uri, namespaces)
      end
    end
    def on_end_element_ns(name, prefix, uri)
      qname = FHGelsenkirchen::createQname(prefix, name)
      if (!@bIgnoring || !@bSeenGroupMember)   #normaler fall
        return super(name, prefix, uri)
      else    #zur Zeit am ignorieren
        if (qname == @IgnoredQName)
          @bIgnoring = false
          @IgnoredQName = nil
        end
        return false
      end
    end

    def on_characters(chars)
      if (!@bIgnoring || !@SeenGroupMember)    #nur wenn nicht gerade ignoriert wird oder es noch vor dem ersten GroupMember ist
        super(chars)
      end
    end
  end
end