require 'CityGML/Handler/SimpleGMLHandler'
require 'CityGML/Handler/SurfaceMemberHandler'
require 'CityGML/Objects/SurfaceMember'

module FHGelsenkirchen
  class LodXHandler < SimpleGMLHandler
    attr_accessor :CurLodXObject
    def getCurLodXObject()
      return @curObject
    end

    def initialize(bSaveOtherTags)
      super(bSaveOtherTags)
      @SurfaceMemberHandler = SurfaceMemberHandler.new(bSaveOtherTags)
    end

    def on_start_element_ns(name, attributes, prefix, uri, namespaces)
      qname = FHGelsenkirchen::createQname(prefix, name)
      case (name)
      when "surfaceMember":
       #   puts "surfaceMember"
          #Eventuelle PreObjects speichern
        if (@curObject.PreObjects == nil || @curObject.PreObjects.empty?)
          SaveCurrentPreObjects()
        end
        #neues Objekt anlegen
        begin
          if(@curObject.Surfaces.size > 0)
            newSurfaceMember = SurfaceMember.new(@curObject, qname, attributes, @bSaveOtherTags, @curObject.Surfaces[-1].CompositeSurfaceId)
          else
            newSurfaceMember = SurfaceMember.new(@curObject, qname, attributes, @bSaveOtherTags, "")
          end
        rescue => e
          puts e
        end
        
        #newSurfaceMember.DebugLine = GMLParser.SaxGMLHandler.DebugXMLLine;
        @curObject.Surfaces << newSurfaceMember
        #Handler reset
        @SurfaceMemberHandler.resetHandler(self, newSurfaceMember)
        return @SurfaceMemberHandler
      else
        return super(name, attributes, prefix, uri, namespaces)
      end

    end

  end
end