require 'CityGML/Handler/SimpleGMLHandler'
module FHGelsenkirchen
  class ReliefFeatureHandler < SimpleGMLHandler


    attr_accessor :CurReliefFeature

    def initialize(bSaveOtherTags)
      super(bSaveOtherTags)
      @EMPTYRELIEFFEATURE = 0
      @TRIANGLE = 1
      @POS = 2
      @POSLIST = 4
      @CharBuffer = ""
      @ReliefFeatureBitMask = 0
    end

    def on_start_element_ns(name, attributes, prefix, uri, namespaces)
      case (name)
      when "Triangle":
          @ReliefFeatureBitMask |= @TRIANGLE
      when "posList":
          @ReliefFeatureBitMask |= @POSLIST
      when "pos":
          raise Exception, "pos ist für ReliefFeature nicht implementiert. Nur posList"
      end
      return super(name, attributes, prefix, uri, namespaces)
    end

    def on_end_element_ns(name, prefix, uri)
      #floatpattern = Regexp.new('[0-9]+[eE][-+]?[0-9]+|[-+]?[0-9]*\.?[0-9]+') #Regulärer Ausdruck für float Zahlen
      case (name)
      when "Triangle":
          @ReliefFeatureBitMask &= ~@TRIANGLE
      when "posList":
          @ReliefFeatureBitMask &= ~@POSLIST
        posListValue = @CharBuffer
        @CharBuffer = ""
        mcPL = posListValue.split(' ')
        #mcPL = posListValue.scan(floatpattern)
        #if (mcPL.length  != 3*3 + 3)
        #  raise GMLParserException, "posList failure: pos count on numbers of Triangle posList has to be 12"
        #end
        newTriangle = []
        for i in 0..2  #der letzte Vertex ist der erste, nur die ersten interessieren
          newTriangle[i] = [mcPL[3 * i], mcPL[3 * i + 1], mcPL[3 * i + 2]]
        end
        @curObject.Triangles << newTriangle
      end
      return super(name, prefix, uri)
    end
    def on_characters(chars)
      if ((@ReliefFeatureBitMask & @POS) != 0)   #Es werden gerade Positionsangaben geparst
        @CharBuffer << chars
      end
      if ((@ReliefFeatureBitMask & @POSLIST) != 0)   #Es werden gerade Positionsangaben als postList geparst
        @CharBuffer << chars
      end
      super(chars)
    end

  end
end