#Hilfsklassen und Methoden
module FHGelsenkirchen
  #Klasse zum Speichern von einem Materialinformationen
  class Material
    attr_reader :diffuseColor
    attr_reader :transparency
    def initialize(diffuseColor, transparency)
      @diffuseColor = diffuseColor
      @transparency = transparency
    end
  end

  #Klasse zum Speichern von Texturinformationen
  class Texture
    attr_reader :imageURI
    attr_reader :wrapMode
    attr_reader :textureCoordinates
    def initialize(imageURI, textureCoordinates, wrapMode)
      @imageURI = imageURI
      @wrapMode = wrapMode
      @textureCoordinates = textureCoordinates
    end
  end

  #Sucht in den cityObjects, ob es ein RoofSurface, WallSurface oder Groundsurface ist
  #Diese Informationen stecken im LODBoundedBy
  #Parameter 1: cityObjects-Objekt
  def FHGelsenkirchen::findSurfaceType(cityObjects)
    surfacetype = Hash.new
    return surfacetype if(cityObjects == nil || cityObjects.empty?)
    i = 1
    cityObjects.each do |cityObject|
      if(cityObject.class == CityObjectGroup)
        cityObject.GroupMember.each do |groupmember|
          groupmember.GMLObject.LODBoundedBy.each do |lodboundedby|
            next if(lodboundedby == nil)
            lodboundedby.each do |boundedby|
              boundedby.LodXObject.Surfaces.each do |surface|
                next if(surface == nil)
                surfacetype[i] = [boundedby.surfaceTyp, boundedby.surfaceAttributes]
                i += 1
                #if(surface.xlinkhref != nil and !surface.xlinkhref.empty?)
                #  surfacetype[surface.xlinkhref] = [boundedby.surfaceTyp, boundedby.surfaceAttributes]
                #end
                #if(surface.sSurfaceID != nil or !surface.sSurfaceID.empty?)
                #  surfacetype[surface.sSurfaceID] = [boundedby.surfaceTyp, boundedby.surfaceAttributes]
                #end
              end
            end
          end
        end
      elsif(cityObject.class == Generic3DObject)
        cityObject.LODBoundedBy.each do |lodboundedby|
          next if(lodboundedby == nil)
          lodboundedby.each do |boundedby|
            boundedby.LodXObject.Surfaces.each do |surface|
              next if(surface == nil)
              surfacetype[i] = [boundedby.surfaceTyp, boundedby.surfaceAttributes]
              i += 1
              #if(surface.xlinkhref != nil and !surface.xlinkhref.empty?)
              #  surfacetype[surface.xlinkhref] = [boundedby.surfaceTyp, boundedby.surfaceAttributes]
              #end
              #if(surface.sSurfaceID != nil or !surface.sSurfaceID.empty?)
              #  surface.sSurfaceID
              #  surfacetype[surface.sSurfaceID] = [boundedby.surfaceTyp, boundedby.surfaceAttributes]
              #end
            end
          end
        end
      end
    end
    return surfacetype
  end

  #Gibt Prefix und Name eines XML-Elements  zusammen als String zurück
  def FHGelsenkirchen::createQname(prefix, name)
    if prefix != nil
      return "#{prefix}:#{name}"
    else
      return name
    end
  end
  #Klasse zum Speichern von 3D-Koordinaten
  class GMLVertex
    def initialize()
      #createbyfloat oder String nutzen
    end
    attr_reader :X
    attr_reader :Y
    attr_reader :Z

    #Mit Float initialisieren
    #Parameter 1: X-Wert
    #Parameter 2: Y-Wert
    #Parameter 3: Z-Wert
    def createbyfloat(v1, v2, v3)
      @X = v1
      @Y = v2
      @Z = v3
    end

    #Mit String initialisieren
    #Parameter 1: String, in dem X,Y und Z Wert durch Leerzeichen getrennt vorhanden sind
    def createbyString(parseString)
      mc = parseString.split(' ')
      if (mc.length % 3 != 0)
        raise GMLParserException,"Parseerror: Count of \"Pos\" is not 3 (" + parseString +")"
      end
      @X = mc[0]
      @Y = mc[1]
      @Z = mc[2]
    end
  end
  
  #Klasse zum Speichern von Texturkoordinaten
  class GMLVertexTextureCoordinate
    attr_reader :t1 # U-Koordinate
    attr_reader :t2 # V-Koordinate
    def initialize(t1, t2)
      @t1 = t1
      @t2 = t2
    end
  end
end