module FHGelsenkirchen
  #Plugin wird erst ab Version 7.0 angezeigt
  version_required = 7.0
  begin
    if (Sketchup.version.to_f < version_required)
      UI.messagebox("You need SketchUp " + version_required.to_s +
          " to run the CityGML-Plugin. You can download it at www.sketchup.google.com")
    else
      tool_menu = UI.menu "Plugins"
      m2 = tool_menu.add_submenu("CityGML"){}
      m2.add_item("Import"){
        ImportService.new()
      }
      m2.add_item("Export"){
        CityGMLExport.new(false,nil)
      }
      m2.add_item("Batch Export"){
        BatchExporter.new()
      }
      m2.add_item("Feedback..."){
        FeedbackService.new()
      }
      m2.add_item("Search for updates..."){
        UpdateService.new()
      }
      enable = false
      if(enable)
        m2.add_item("Bocholt validieren"){
          validator = ValidatorBo.new
          filename = UI.openpanel "IDList", nil, "*"
          validator.validate(filename, true) if(filename != nil)
        }
        m2.add_item("Validator"){
          validator = Validator.new
          filename = UI.openpanel "CityGML-File", nil, "*"
          validator.validate(filename, true) if(filename != nil)
        }
      end
    end
  rescue => e
    puts e
    puts e.backtrace
  end
end