require 'libxml'
require 'xml'
module FHGelsenkirchen
  class ValidatorBo
    class Handler
      include XML::SaxParser::Callbacks

      def initialize(idList, sketchup)
        @glog = File.new(File.dirname(idList) + "\\Not_planar.txt", "w")
        @glog.close
        @glog = File.new(File.dirname(idList) + "\\not_planar_list.txt", "w")
        @glog.close
        @glog = File.new(File.dirname(idList) + "\\Ring_not_closed_Log.txt", "w")
        @glog.close
        @glog = File.new(File.dirname(idList) + "\\Duplicated_points_Log.txt", "w")
        @glog.close
        @enable_sketchup = sketchup
        @ges_nr_exterior = 0
        @ges_nr_interior = 0
        @ges_notplanar = 0
        @ges_ringnotclosed = 0
        @ges_duplicatedpts = 0
        @ges_lessthen3pts = 0
        if(sketchup)
          @entities = Sketchup.active_model.entities
        end
        f = File.new(idList, "r")
        z = 1
        names = []
        begin
          while (line = f.readline)
            gmlname = line.strip! + ".ZippyGML.ccl"
            gmlname = File.dirname(idList) + "\\ZippyGML\\#{gmlname}"
            names << gmlname
          end
        rescue EOFError
          f.close
        end
        names.each do |n|
          @nr_exterior = 0
          @nr_interior = 0
          @poslistfailure = 0
          @posfailure = 0
          @ringnotclosed = 0
          @duplicatedpts = 0
          @lessthen3pts = 0
          @notplanar = 0
          @exterior = []
          @interiors = Hash.new
          @EMPTYSURFACE = 0
          @POS = 1
          @POSLIST = 2
          @TEXTUREMAP = 4
          @TEXTURECOORDINATES = 8
          @interior = false
          @polygon = false
          @SurfaceBitMask = @EMPTYSURFACE
          @CharBuffer = ""
          @linearringid = ""
          @polygonid = ""
          @notplanarids = []
          @duplicatedptsids = []
          @less3ptsids = []
          @notclosedids = []
          @eninteriorid = false
          @enexteriorid = false
          @interiorid = ""
          begin
            @parser = XML::SaxParser.file(n)
            @parser.callbacks= self
            @parser.parse()
            writeoutput(idList, n, z, names.length)
            z += 1
            #name = File.dirname(sXmlFile) + "\\ErrorLog.txt"
            #Thread.new() { system("notepad \"#{name}\"") }
          rescue =>e
            puts e
            puts e.backtrace
          end
        end
        s = "Number of Exteriors: #{@ges_nr_exterior}\n"
        s << "Number of Interiors: #{@ges_nr_interior}\n"
        s << "Not planar: #{@ges_notplanar}\n"
        s << "Ring not Closed: #{@ges_ringnotclosed}\n"
        s << "Duplicated Points in Polygon: #{@ges_duplicatedpts}\n"
        s << "Polygons with less then 3 points: #{@ges_lessthen3pts}\n"
        puts s
        @glog = File.new(File.dirname(idList) + "\\Validator_Log.txt", "w")
        @glog << s
        @glog.close
      end
      def writeoutput(idList, gmlname, z, x)
        @ges_nr_exterior += @nr_exterior
        @ges_nr_interior += @nr_interior
        s = "Done: #{z}/#{x}\n"
        s << "Number of Exteriors: #{@ges_nr_exterior}\n"
        s << "Number of Interiors: #{@ges_nr_interior}\n"
        s << "Not planar: #{@ges_notplanar}\n"
        s << "Ring not Closed: #{@ges_ringnotclosed}\n"
        s << "Duplicated Points in Polygon: #{@ges_duplicatedpts}\n"
        s << "Polygons with less then 3 points: #{@ges_lessthen3pts}\n"
        @glog = File.new(File.dirname(idList) + "\\Validator_Log.txt", "w")
        @glog << s
        @glog.close
        return if(@notplanar == 0 and @ringnotclosed == 0 and @duplicatedpts == 0 and @lessthen3pts==0)
        @log = File.new(File.dirname(idList) + "\\Log\\#{File.basename(gmlname, ".ccl")}_Log.txt", "w")
        @log << "Validator-Log\n"
        @ges_notplanar += @notplanar
        @ges_ringnotclosed += @ringnotclosed
        @ges_duplicatedpts += @duplicatedpts
        @ges_lessthen3pts += @lessthen3pts


        s = "Number of Exteriors: #{@nr_exterior}\n"
        s << "Number of Interiors: #{@nr_interior}\n"
        s << "Not planar: #{@notplanar}\n"
        s << "Ring not Closed: #{@ringnotclosed}\n"
        s << "Duplicated Points in Polygon: #{@duplicatedpts}\n"
        s << "Polygons with less then 3 points: #{@lessthen3pts}\n"
        #puts s
        @log << s
        if(@notplanar > 0)
          @log << "Not planar Polgon-IDs\n"
          @log << @notplanarids
          @glog = File.new(File.dirname(idList) + "\\Not_planar.txt", "a")
          @glog << "#{File.basename(gmlname, ".CityGML.ccl")}:\n"
          @glog << @notplanarids
          @glog << "\n"
          @glog.close
          @glog = File.new(File.dirname(idList) + "\\not_planar_list.txt", "a")
          @glog << @notplanarids
          @glog.close
        end
        if(@duplicatedpts > 0)
          @log << "Duplicated Points in Polygon-IDs\n"
          @log << @duplicatedptsids
          @glog = File.new(File.dirname(idList) + "\\Duplicated_points_Log.txt", "a")
          @glog << "#{File.basename(gmlname, ".CityGML.ccl")}:\n"
          @glog << @duplicatedptsids
          @glog << "\n"
          @glog.close
        end
        if(@ringnotclosed > 0)
          @log << "Polygon not closed IDs\n"
          @log << @notclosedids
          @glog = File.new(File.dirname(idList) + "\\Ring_not_closed_Log.txt", "w")
          @glog << "#{File.basename(gmlname, ".CityGML.ccl")}:\n"
          @glog << @notclosedids
          @glog << "\n"
          @glog.close
        end
        if(@lessthen3pts > 0)
          @log << "Polygon-IDs less then 3 points\n"
          @log << @less3ptsids
        end

        @log.close

      end
      def on_start_element_ns(name, attributes, prefix, uri, namespaces)
        case (name)
        when "LinearRing"
          begin
            if(@enexteriorid == true)
              @linearringid = attributes.fetch("id")
            else
              @interiorid = attributes.fetch("id")
              @interiors[@interiorid] = []
            end
          rescue => e
            #puts e
          end
        when "Polygon"
          @polygon = true
          begin
            @polygonid = attributes.fetch("id")
          rescue => e
          end
        when "pos"
          @SurfaceBitMask |= @POS if(@polygon == true)
        when "posList"
          @SurfaceBitMask |= @POSLIST if(@polygon == true)
        when "interior"
          @eninteriorid = true
          @interior = true
          #@interiors[@interiorid] == []
        when "exterior"
          @enexteriorid = true
        end
      end

      def on_end_element_ns(name, prefix, uri)
        case (name)
        when "Polygon"
          begin
            @nr_exterior += 1 if(@exterior.size > 1)
            @nr_interior += @interiors.size
            if(@exterior[0] != @exterior[-1])
              @ringnotclosed += 1
              if(@linearringid != "")
                @notclosedids << @linearringid  + "\n"
              elsif(@polygonid != "")
                @notclosedids << @polygonid  + "\n"
              end
            end
            @exterior.delete_at(@exterior.size - 1)
            @interiors.each_pair do |key,interior|
              @ringnotclosed += 1 if(interior[0] != interior[-1])
              interior.delete_at(interior.size - 1)
              if(interior.uniq! != nil)
                @duplicatedpts += 1
                @duplicatedptsids << key  + "\n" if(key != "")
              end
              if(interior.size < 3)
                @lessthen3pts += 1
                @less3ptsids << key  + "\n" if(key != "")
              end
            end
            if(@exterior.uniq! != nil)
              if(@linearringid != "")
                @duplicatedptsids << @linearringid  + "\n"
              elsif(@polygonid != "")
                @duplicatedptsids << @polygonid  + "\n"
              end
              @duplicatedpts += 1
            end
            if(@exterior.size < 3)
              if(@linearringid != "")
                @less3ptsids << @linearringid  + "\n"
              elsif(@polygonid != "")
                @less3ptsids << @polygonid  + "\n"
              end
              @lessthen3pts += 1
            end
            if(@enable_sketchup and @exterior.size > 2)
              begin
                face = @entities.add_face(@exterior)
                @entities.clear!
              rescue => e
                if(e.message == "Points are not planar")
                  @notplanar += 1
                  @notplanarids << @polygonid  + "\n" if(@polygonid != "")
                  #@notplanarids << @linearringid  + "\n" if(@linearringid != "")
                end
              end
            end
          rescue => err
            puts err.message
            puts err.backtrace
            return
          end
          @polygon = false
          @linearringid = ""
          @polygonid = ""
          @exterior = []
          @interiors = Hash.new
        when "pos"
          if(@polygon == true)
            begin
              pos = @CharBuffer.split(' ')
              if (pos.length % 3 != 0)
                @posfailure += 1
                #puts "Parseerror: Count of \"Pos\" is not 3 (" + @CharBuffer +")"
              end
              if(@interior == true)
                @interiors[@interiorid] << [pos[0].to_f, pos[1].to_f, pos[2].to_f]
              else
                @exterior << [pos[0].to_f, pos[1].to_f, pos[2].to_f]
              end
              @SurfaceBitMask &= ~@POS
              @CharBuffer = ""
            rescue => err
              puts err
              puts err.backtrace
            end
          end
        when "posList"
          if(@polygon == true)
            mc_p_l = @CharBuffer.split(' ')
            if (mc_p_l.length%3 != 0)
              @poslistfailure += 1
              puts "posList failure: pos count is not a power of 3"
            end
            tmp = []
            for i in 0..(mc_p_l.length/3)-1
              tmp << [mc_p_l[3*i].to_f, mc_p_l[3*i + 1].to_f, mc_p_l[3*i + 2].to_f]
            end
            if(@interior == true)
              @interiors[@interiorid] = tmp
            else
              @exterior = tmp
            end
            @SurfaceBitMask &= ~@POSLIST
            @CharBuffer = ""
          end
        when "interior"
          @interior = false
          @eninteriorid = false
        when "exterior"
          @enexteriorid = false
        end
      end

      def on_characters(chars)
        if ((@SurfaceBitMask & @POS) != 0)   #Es werden gerade Positionsangaben geparst
          @CharBuffer << chars
        elsif ((@SurfaceBitMask & @POSLIST) != 0)   #Es werden gerade Positionsangaben als postList geparst
          @CharBuffer << chars
        end
      end
    end
    def validate(sXmlFile, sketchup)
      Handler.new(sXmlFile, sketchup)
    end
  end
end
#validator = FHGelsenkirchen::Validator.new
#validator.validate("E:\\CityGML Modelle\\Benfer Bottrop\\Bottrop.xml", false)

#validator.validate("E:\\CityGml\\6010_Ge_CityGml.xml", false)